net.sf.saxon.functions

## Class Minimax

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.FunctionCall
    - - net.sf.saxon.functions.SystemFunctionCall
      - - net.sf.saxon.functions.CollatingFunction
        - - net.sf.saxon.functions.Minimax

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, Callable, InstructionInfo, Locator
  Direct Known Subclasses:
    Max, Min

      public abstract class Minimax
      extends CollatingFunction

  This class implements the min() and max() functions
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `MAX`
    `static int` | `MIN`

    - ### Fields inherited from class net.sf.saxon.functions.CollatingFunction

      `staticCollation`

    - ### Fields inherited from class net.sf.saxon.functions.SystemFunctionCall

      `operation`

    - ### Fields inherited from class net.sf.saxon.expr.FunctionCall

      `argument`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Minimax()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `checkArguments(ExpressionVisitor visitor)` Static analysis: prevent sorting of the argument and preallocate a comparer if possible
    `int` | `computeCardinality()` Determine the cardinality of the function.
    `Expression` | `copy()` Copy an expression.
    `boolean` | `equals(Object o)` Determine whether two expressions are equivalent
    `AtomicValue` | `evaluateItem(XPathContext context)` Evaluate the function
    `BuiltInAtomicType` | `getArgumentType()`
    `AtomicComparer` | `getAtomicComparer(XPathContext context)`
    `protected int` | `getCollationArgument()` Get the argument position (0-based) containing the collation name
    `AtomicComparer` | `getComparer()`
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the Minimax expression
    `int` | `getImplementationMethod()` Get implementation method
    `ItemType` | `getItemType(TypeHierarchy th)` Determine the item type of the value returned by the function
    `MinimaxAdjunct` | `getStreamingAdjunct()` Get a class that supports streamed evaluation of this expression
    `boolean` | `isIgnoreNaN()` Test whether NaN values are to be ignored
    `static AtomicValue` | `minimax(SequenceIterator iter, int operation, AtomicComparer atomicComparer, boolean ignoreNaN, XPathContext context)` Static method to evaluate the minimum or maximum of a sequence
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `void` | `setIgnoreNaN(boolean ignore)` Indicate whether NaN values should be ignored.
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Type-check the expression

    - ### Methods inherited from class net.sf.saxon.functions.CollatingFunction

      `bindStaticContext, expandCollationURI, getAtomicComparer, getCollator, getCollatorFromLastArgument, getExpressionBaseURI, getPreAllocatedAtomicComparer, getStaticCollation, preAllocateComparer`

    - ### Methods inherited from class net.sf.saxon.functions.SystemFunctionCall

      `addContextDocumentArgument, addDocToPathMap, computeSpecialProperties, equalOrNull, getContextNode, getConvertingCallable, getDefaultArgumentNode, getDetails, getErrorCodeForTypeErrors, getFunctionItemType, getOperation, getRequiredType, iterateSubExpressionInfo, makeSystemFunction, setDetails, useContextItemAsDefault`

    - ### Methods inherited from class net.sf.saxon.expr.FunctionCall

      `addExternalFunctionCallToPathMap, checkArgumentCount, explain, getArguments, getDisplayName, getExpressionName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, preEvaluate, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.Callable

      `call`

- - ### Field Detail

    - #### MIN

          public static final int MIN

      See Also:
        Constant Field Values

    - #### MAX

          public static final int MAX

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Minimax

          public Minimax()

  - ### Method Detail

    - #### getCollationArgument

          protected int getCollationArgument()

      Get the argument position (0-based) containing the collation name
      Specified by:
        `getCollationArgument` in class `CollatingFunction`
      Returns:
        the position of the argument containing the collation URI

    - #### setIgnoreNaN

          public void setIgnoreNaN(boolean ignore)

      Indicate whether NaN values should be ignored. For the external min() and max() function, a NaN value in the input causes the result to be NaN. Internally, however, min() and max() are also used in such a way that NaN values should be ignored.
      Parameters:
        `ignore` - true if NaN values are to be ignored when computing the min or max.

    - #### isIgnoreNaN

          public boolean isIgnoreNaN()

      Test whether NaN values are to be ignored
      Returns:
        true if NaN values are to be ignored. This is the case for internally-generated min() and max() functions used to support general comparisons

    - #### getComparer

          public AtomicComparer getComparer()

    - #### getArgumentType

          public BuiltInAtomicType getArgumentType()

    - #### getImplementationMethod

          public int getImplementationMethod()

      Get implementation method
      Overrides:
        `getImplementationMethod` in class `SystemFunctionCall`
      Returns:
        a value that indicates this function is capable of being streamed

    - #### checkArguments

          public void checkArguments(ExpressionVisitor visitor)
                              throws XPathException

      Static analysis: prevent sorting of the argument and preallocate a comparer if possible
      Overrides:
        `checkArguments` in class `CollatingFunction`
      Parameters:
        `visitor` - the expression visitor
      Throws:
        `XPathException` - if the arguments are incorrect

    - #### computeCardinality

          public int computeCardinality()

      Determine the cardinality of the function.
      Overrides:
        `computeCardinality` in class `SystemFunctionCall`
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Type-check the expression
      Overrides:
        `typeCheck` in class `FunctionCall`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Perform optimisation of an expression and its subexpressions.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `SystemFunctionCall`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Determine the item type of the value returned by the function
      Overrides:
        `getItemType` in class `SystemFunctionCall`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the statically inferred type of the expression

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Overrides:
        `copy` in class `CollatingFunction`
      Returns:
        the copy of the original expression

    - #### equals

          public boolean equals(Object o)

      Determine whether two expressions are equivalent
      Overrides:
        `equals` in class `CollatingFunction`

    - #### evaluateItem

          public AtomicValue evaluateItem(XPathContext context)
                                   throws XPathException

      Evaluate the function
      Overrides:
        `evaluateItem` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### getAtomicComparer

          public AtomicComparer getAtomicComparer(XPathContext context)
                                           throws XPathException

      Throws:
        `XPathException`

    - #### minimax

          public static AtomicValue minimax(SequenceIterator iter,
                            int operation,
                            AtomicComparer atomicComparer,
                            boolean ignoreNaN,
                            XPathContext context)
                                     throws XPathException

      Static method to evaluate the minimum or maximum of a sequence
      Parameters:
        `iter` - Iterator over the input sequence
        `operation` - either `MIN` or `MAX`
        `atomicComparer` - an AtomicComparer used to compare values
        `ignoreNaN` - true if NaN values are to be ignored
        `context` - dynamic evaluation context
      Returns:
        the min or max value in the sequence, according to the rules of the fn:min() or fn:max() functions
      Throws:
        `XPathException` - typically if non-comparable values are found in the sequence

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the Minimax expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### getStreamingAdjunct

          public MinimaxAdjunct getStreamingAdjunct()

      Get a class that supports streamed evaluation of this expression
      Overrides:
        `getStreamingAdjunct` in class `Expression`
      Returns:
        the relevant StreamingAdjunct, or null if none is available

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.